function lengthOfTextContained (focusNode) {
	var length = 0;
	if (focusNode.hasChildNodes()) {
		focusNode = focusNode.firstChild;
		length = lengthOfTextContained(focusNode);
		while (focusNode.nextSibling !== null) {
			focusNode = focusNode.nextSibling;
			length = length + lengthOfTextContained(focusNode);
		}	
	} else {
		if (focusNode.nodeType == 3) {
			length = focusNode.length;
		}
	}
	return length;
}


function  lengthOfTextBeforeNode (focusNode) {
	var posZaehler = 0;
	while (!(focusNode.nodeType == 1 && focusNode.tagName == "DIV" && focusNode.id == "mw-content-text")){
		while (focusNode.previousSibling !== null) {
			focusNode = focusNode.previousSibling;
			posZaehler = posZaehler + lengthOfTextContained(focusNode);
		}
		focusNode = focusNode.parentNode;
	}
	return posZaehler;
}


/**
 * getPositionOfSelection returns the indexes of the start and the end of the selection within the plain text,
 * that is displayed in the browser
 *
 * @param startPos index of the start position of the selection within the DOM node, in which the selection starts
 * @param endPos index of the end position of the selection within the DOM node, in which the selection ends
 */
function getPositionOfSelection(startPos,endPos) {
	
	var focusNode;
	var anchorNode;
	
	//get the node, in which the selection is started (mouse button is pressed at that position)
	anchorNode = window.getSelection().anchorNode;
	//get the node, in which the selection is ended (mouse button is released at that position; may be *before* the anchorNode)
	focusNode = window.getSelection().focusNode;
	
	if (focusNode == anchorNode && startPos == endPos) {
		var resultArray = new Array("ERROR",null);
		return (resultArray);
	}
	
	//abort action, if focusNode is not p-Element but mw-content-text
	//that happens, if the user releases the mouse not over the text, but over the white space on the right side of the text
	//(mostly to assure that he selects the whole line)
	//give an alert, that he has to release the mouse OVER the last letter of the selection!
	if(focusNode.parentNode.nodeType == 1 && focusNode.parentNode.tagName == "DIV" && focusNode.parentNode.id == "mw-content-text") {
		alert("You need to release the mouse OVER the last letter of the selected area! (Not on over 'empty' space)");
		location.reload();
	}
	
	var posZaehler1 = 0;
	var posZaehler2 = 0;
    
	posZaehler1 = lengthOfTextBeforeNode(anchorNode);
	posZaehler2 = lengthOfTextBeforeNode(focusNode);
	
	//take care if selection was made "from right to left"
	if (posZaehler1<=posZaehler2) {
		posZaehler1 = posZaehler1 + startPos;
		posZaehler2 = posZaehler2 + endPos;
	} else {
		posZaehler1 = posZaehler1 + endPos;
		posZaehler2 = posZaehler2 + startPos;
		
		var help = posZaehler1;
		posZaehler1 = posZaehler2;
		posZaehler2 = help;
	}
	
	var posZaehler = new Array(posZaehler1, posZaehler2);
	
	//span class="mw-headline"
	return (posZaehler);
}